package com.google.code.morphia.converters;


import com.google.code.morphia.mapping.MappedField;
import com.google.code.morphia.mapping.MappingException;


/**
 * @author Uwe Schaefer, (us@thomas-daily.de)
 * @author scotthernandez
 */
@SuppressWarnings({"rawtypes" })
public class EnumConverter extends TypeConverter implements SimpleValueConverter {

  @Override
  protected boolean isSupported(final Class c, final MappedField optionalExtraInfo) {
    return c.isEnum();
  }

  @Override
  public Object decode(final Class targetClass, final Object fromDBObject, final MappedField optionalExtraInfo) throws MappingException {
    if (fromDBObject == null) {
      return null;
    }
    return Enum.valueOf(targetClass, fromDBObject.toString());
  }

  @Override
  public Object encode(final Object value, final MappedField optionalExtraInfo) {
    if (value == null) {
      return null;
    }

    return getName((Enum) value);
  }

  private <T extends Enum> String getName(final T value) {
    return value.name();
  }
}
